 ! run.br - ScreenIO Run Screen Library        #AutoNumber# 1000,10
 !
 ! Created 1/1/2009 by Gabriel Bakker
 !
 !
 !  This library runs screens from a function to preserve library variables
 !  needed by calling screen.
 !
 !  Also, this library will make a tab by combining several screenIO screens
 !

    def library fnRun(Screen$*255;key$,ParentKey$*255,DisplayOnly) ! Run a screen through a function
       let fnEstablishLibraryLinkage
       let fnCallScreen$(Screen$,key$,ParentKey$,DisplayOnly)
    fnend

    def library fnRunTab(&ExitMode,TabExitMode,Screen$*255;key$,ParentKey$*255,DisplayOnly) ! Run a screen on a tab
       let fnEstablishLibraryLinkage
       if len(trim$(fnCallScreen$(Screen$,key$,ParentKey$,DisplayOnly))) and fkey<>92 then
          let fnRunTab=1
       end if
       if fkey=92 then let ExitMode=TabExitMode
    fnend

    def library fnRunTabs(mat Screen$,mat Caption$,Rows,Cols;InsideScreen,Predraw,MsgScreen$,MsgRow,MsgCol,StartScreen,BlockESC,ExitOnCancel,Key$*255,ParentKey$*255)
       let fnRunTabs=fnReturnValue(fnTabs$(mat Screen$,mat Caption$,Rows,Cols,InsideScreen,Predraw,MsgScreen$,MsgRow,MsgCol,StartScreen,BlockESC,ExitOnCancel,Key$,ParentKey$))
    fnend

    def library fnRunTabs$(mat Screen$,mat Caption$,Rows,Cols;InsideScreen,Predraw,MsgScreen$,MsgRow,MsgCol,StartScreen,BlockESC,ExitOnCancel,Key$*255,ParentKey$*255)
       let fnRunTabs$=fnTabs$(mat Screen$,mat Caption$,Rows,Cols,InsideScreen,Predraw,MsgScreen$,MsgRow,MsgCol,StartScreen,BlockESC,ExitOnCancel,Key$,ParentKey$)
    fnend

    def fnTabs$(mat Screen$,mat Caption$,Rows,Cols;InsideScreen,Predraw,MsgScreen$,MsgRow,MsgCol,StartScreen,BlockESC,ExitOnCancel,&Key$,&ParentKey$,___,Index,CurrentScreen,dummy$,ReturnValue$*255,Return$*255)
       let fnEstablishLibraryLinkage

       dim Inputwindows(1)
       dim PredrawWindows(1)
       mat InputWindows(udim(mat screen$))
       mat PredrawWindows(udim(mat screen$))
       mat PredrawMessage(udim(mat screen$))

       for Index=1 to udim(mat Screen$)
          open #(InputWindows(Index):=fnGetFileNumber): "srow=2,scol=2,rows="&str$(Rows)&",cols="&str$(Cols)&",tab="&Caption$(Index), display, outin
       next Index

       if StartScreen then
          let CurrentScreen=StartScreen
          input #InputWindows(CurrentScreen), fields "2,2,C 1,,NOWAIT" : dummy$
          print #InputWindows(CurrentScreen), fields "2,2,C 1" : ""
       else
          let Currentscreen=1
       end if

       if Predraw then
          let PredrawWindows(Currentscreen)=fnDisplayScreen(Screen$(Currentscreen),Key$,1,1,ParentKey$,InputWindows(Currentscreen))
          if MsgScreen$<>"" then
             let PredrawMessage(Currentscreen)=fnDisplayScreen(MsgScreen$,Key$,MsgRow,MsgCol,ParentKey$,PredrawWindows(Currentscreen))
          end if
          let scr_freeze
       else
          if MsgScreen$<>"" then
             let PredrawMessage(Currentscreen)=fnDisplayScreen(MsgScreen$,Key$,MsgRow,MsgCol,ParentKey$,InputWindows(Currentscreen))
             let scr_freeze
          end if
       end if

       for Index=1 to udim(mat Screen$)
          if Index<>CurrentScreen then ! Skip the one we already did
             if Predraw then
                let PredrawWindows(Index)=fnDisplayScreen(Screen$(Index),Key$,1,1,ParentKey$,InputWindows(Index))
                if MsgScreen$<>"" then
                   let PredrawMessage(Index)=fnDisplayScreen(MsgScreen$,Key$,MsgRow,MsgCol,ParentKey$,PredrawWindows(Index))
                end if
                let scr_freeze
             else
                if MsgScreen$<>"" then
                   let PredrawMessage(Index)=fnDisplayScreen(MsgScreen$,Key$,MsgRow,MsgCol,ParentKey$,InputWindows(Index))
                   let scr_freeze
                end if
             end if
          end if
       next Index

       do
          if InsideScreen then
             let ReturnValue$=fnCallScreen$(Screen$(CurrentScreen),Key$,1,1,ParentKey$,InputWindows(CurrentScreen))
          else
             let ReturnValue$=fnfm$(Screen$(CurrentScreen),Key$,1,1,ParentKey$,InputWindows(CurrentScreen))
          end if
          if CurrentScreen=1 and fkey<>92 then
             let fnTabs$=ReturnValue$
          end if
          let scr_freeze

          if Fkey=92 then ! If A Tab Is Clicked Then Jump To That Tab
             let Currentscreen=Srch(Mat Inputwindows,Curtab(InputWindows(1)))
          end if
       loop Until (fkey=99 and ~BlockESC) or fkey=93 or (fkey<>92 and ExitOnCancel)
 !
       for Index=1 to Udim(Mat Inputwindows)
          if MsgScreen$<>"" then close #PredrawMessage(Index):
          if Predraw then close #PredrawWindows(Index):
          close #Inputwindows(Index):
       next Index
    fnend

 !
 ! #Autonumber# 99000,10
    def fnEstablishLibraryLinkage
       if ~LinkageEstablished then
          let LinkageEstablished=1
          library "fileio" : fnGetFileNumber, fnOpenFile
          library "screenio" : fnCallScreen$, fnFm$, fnDisplayScreen
       end if
    fnend
 !
    def Fnreturnvalue(Value$*1000;___,Number)
       let Number=1 ! If Conversion Failed, Then Its A Non-Null String, Return True
       let Number=Val(Value$) conv IGNORE
       let Fnreturnvalue=Number
    fnend

 OPEN: ! ***** Function To Call Library Openfile And Proc Subs
       def Fnopen(Filename$*255, Mat F$, Mat F, Mat Form$; Inputonly, Keynum, Dont_Sort_Subs, Path$*255, Mat Descr$, Mat Field_Widths,___,Index)
          dim _FileIOSubs$(1)*50
          let Fnopen=Fnopenfile(Filename$, Mat F$, Mat F, Mat Form$, Inputonly, Keynum, Dont_Sort_Subs, Path$, Mat Descr$, Mat Field_Widths, Mat _FileIOSubs$)
          for Index=1 to udim(mat _FileIOSubs$) : execute (_FileIOSubs$(Index)) : next Index
       fnend
 !
 ! #Autonumber# 99980,10
 IGNORE: continue